##Dragon AI and Animations


#Dragon AI

execute as @e[type=skeleton_horse,tag=mcdragon1,nbt={Motion:[0.0,-0.0784000015258789,0.0]}] at @s unless entity @a[distance=..3,sort=nearest,nbt={RootVehicle:{Entity:{Tags:["mcdragon1"]}}}] run scoreboard players set @s DragonMovement 0

execute as @e[type=skeleton_horse,tag=mcdragon1,nbt=!{Motion:[0.0,-0.0784000015258789,0.0]}] at @s unless entity @a[distance=..3,sort=nearest,nbt={RootVehicle:{Entity:{Tags:["mcdragon1"]}}}] run scoreboard players set @s DragonMovement 1

#execute as @e[type=skeleton_horse,tag=mcdragon1,tag=!Cmcdragon1] run data merge entity @s {Silent:1b,Tame:1b,Tags:["mcdragon1","Cmcdragon1"],Attributes:[{Name:generic.movement_speed,Base:0.3}],SaddleItem:{id:"minecraft:saddle",Count:1b}}

execute as @e[type=skeleton_horse,tag=mcdragon1] run effect give @s invisibility 200 10 true

#Move Animation

execute as @e[type=skeleton_horse,tag=mcdragon1,nbt={Motion:[0.0,-0.0784000015258789,0.0]},tag=!mcdragonfly,tag=!aj.mcdragon.anim.animation.dragon.default_b] if score @s DragonMovement matches 0 run function mcdragon:mcdragonmech/mcdragonidle

execute as @e[type=skeleton_horse,tag=mcdragon1,nbt=!{Motion:[0.0,-0.0784000015258789,0.0]},tag=!mcdragonfly,tag=!aj.mcdragon.anim.animation.dragon.walk] if score @s DragonMovement matches 1 run function mcdragon:mcdragonmech/mcdragonmove

execute as @e[type=skeleton_horse,tag=mcdragon1,nbt=!{Motion:[0.0,-0.0784000015258789,0.0]},tag=mcdragonfly,tag=!aj.mcdragon.anim.animation.dragon.fly] if score @s DragonMovement matches 1 run function mcdragon:mcdragonmech/dragonfly

execute as @e[type=skeleton_horse,tag=mcdragon1,nbt=!{Motion:[0.0,-0.0784000015258789,0.0]},tag=mcdragonfly,tag=!aj.mcdragon.anim.animation.dragon.hover] if score @s DragonMovement matches 3 run function mcdragon:mcdragonmech/dragonhover

#kill remove

execute as @e[tag=aj.mcdragon.bone] at @s unless entity @e[tag=mcdragon1,distance=..5] run kill @s


#Dragon controls

execute as @e[type=skeleton_horse,tag=mcdragon1,sort=nearest] at @s run function mcdragon:mcdragonmech/dragoncontrol

#Control Reseter

scoreboard players add @a ControlReseter 1

execute as @a if score @s ControlReseter matches 22 run scoreboard players set @s ControlReseter 0


#Dragon Egg Summon

execute as @e[type=item,nbt={Item:{id:"minecraft:ender_eye",Count:1b}},limit=1] at @s if block ~ ~-0.15 ~ dragon_egg run function mcdragon:mcdragonmech/dragoneggspawn


execute at @e[type=minecraft:armor_stand,tag=mcdragonegg1] run particle minecraft:portal ~ ~ ~ 0.1 0.1 0.1 0.4 1 force @a



#Dragon Egg Hatching.....

scoreboard players add @e[tag=mcdragonegg1] DragonEggSpawn 1

execute as @e[tag=mcdragonegg1,type=armor_stand] at @s if score @s DragonEggSpawn matches 17929..17999 run particle block dragon_egg ~ ~ ~ 0.3 0.3 0.3 0.6 2 force @a

execute as @e[tag=mcdragonegg1,type=armor_stand] at @s if score @s DragonEggSpawn matches 18000.. run function mcdragon:mcdragonmech/dragonegghatching


#Dragon Sounds....

scoreboard players add @e[tag=mcdragon1] DragonRoarTime 1

execute as @e[tag=mcdragon1] at @s if score @s DragonRoarTime matches 1 run playsound minecraft:entity.ender_dragon.growl ambient @a ~ ~ ~ 1 1.5

execute as @e[tag=mcdragon1] at @s if data entity @s HurtTime


scoreboard players set @e[tag=mcdragon1,tag=mcdragonfly,scores={DragonFlapWing=17..}] DragonFlapWing 0
scoreboard players set @e[tag=mcdragon1,scores={DragonRoarTime=250..}] DragonRoarTime 0

#Dragon Food

function mcdragon:mcdragonmech/dragonfood

execute as @e[tag=mcdragon1,nbt=!{Health:120.0f}] at @s if entity @e[type=item,tag=dragonfood,distance=0..1.5] run effect give @s minecraft:instant_damage 1 2

execute as @e[tag=mcdragon1,nbt=!{Health:120.0f}] at @s if entity @e[type=item,tag=dragonfood,distance=0..1.5] run playsound entity.panda.eat master @a ~ ~ ~ 1 0.8

execute as @e[tag=mcdragon1,nbt=!{Health:120.0f}] at @s if entity @e[type=item,tag=dragonfood,distance=0..1.5] as @e[type=item,tag=dragonfood,distance=0..1.5] run kill @s


#No Fall Damage

execute as @e[tag=mcdragon1] run data merge entity @s {FallDistance:0f}

#Dragon Hurt

execute as @e[tag=mcdragon1,nbt={HurtTime:10s}] at @s run function mcdragon:mcdragonmech/dragonhurt

execute as @e[tag=mcdragon1,nbt={HurtTime:7s}] at @s run function mcdragon:set_variant/default


